// Engine
Nodes engine, jeu, aliens, lasers, gui;
// Player
PImage playerImage;
Player player;
// Aliens
PImage alienImage;
float alienRadius;
int topA, nowA, intervalA;
// Lasers
PImage laserImage;
Tirs tirs;
// Explosions
//Explosion explosion;
// GUI
int score=0;
PImage fond;
StartGame startgame;
ExitGame exitGame;
boolean pauseInDraw=true;

void setup() {
  //size(1200, 800);
  fullScreen();
  noSmooth();
  // Engine
  engine = new Nodes();
  jeu = new Nodes();
  aliens = new Nodes();
  lasers = new Nodes();
  gui = new Nodes();
  engine.add(jeu);
  jeu.add(aliens);
  jeu.add(lasers);
  engine.add(gui);
  jeu.pause=true;
  // Player
  playerImage=loadImage("playerShip.png");
  player = new Player(0, height-50, 20, playerImage);
  player.scale=0.5;
  jeu.add(player);
  //Aliens
  alienRadius = 20;
  alienImage=loadImage("spaceShip.png");
  topA=0;
  intervalA=500;
  nowA=0;
  // Lasers
  laserImage=loadImage("laser.png");
  tirs = new Tirs();
  jeu.add(tirs);
  jeu.add(new AlienBoum(aliens, lasers));
  //// Explosions
  //explosion=new Explosion(300, 100, 20, laserImage);
  //for (int i=0; i<16; i++) {
  //  explosion.addImage(loadImage("explode"+(i+1)+".png"));
  //}
  //gui.add(explosion);
  // GUI
  pglobal.font=createFont("ZeroCool.ttf", 32);
  textFont(pglobal.font);
  fond=loadImage("fond.png");
  fond.resize(width, height);
  gui.add(new boutonCollisions(10, 20, 220, 30, "Formes de collisions"));
  startgame = new StartGame(width/2-50, height/3, 120, 30, "Démarrer");
  gui.add(startgame);
  exitGame = new ExitGame(width/2-40, height/3+70, 100, 30, "Quitter");
  gui.add(exitGame);
  // Tests
  //pglobal.debug=true;
  //player.vy=-2;
  //novAlien();
}

void draw() {
  background(fond);
  // 2. Aliens
  if (pauseInDraw==false) {
    nowA=millis();
    if (nowA-topA>intervalA) {
      topA = nowA;
      aliens.add(new Alien(random(width), -50, 20, alienImage, player));
    }
  }
  // 3. engine
  engine.run();
  println(aliens.nodes.length);
  // GUI
  fill(255);
  textSize(30);
  text("Score : "+score, width-180, 30);
}
